# Übungsaufgabe: Schemadefinition
```sql
CREATE TABLE Person(
	PNr int NOT NULL,
	Vorname VARCHAR(50) NOT NULL,
	Nachname VARCHAR(50) NOT NULL,
	CONSTRAINT pk_PNr PRIMARY KEY (PNr)
);

CREATE TABLE Produzent(
	PNr int NOT NULL,
	GoldeneSchallplatten int NOT NULL,
	CONSTRAINT pk_PNr PRIMARY KEY (PNr),
	CONSTRAINT fk_PNr FOREIGN KEY (PNr) REFERENCES Person(PNr)
);

CREATE TABLE Musiker(
	PNr int NOT NULL,
	Stil VARCHAR(50) NOT NULL,
	CONSTRAINT pk_PNr PRIMARY KEY (PNr),
	CONSTRAINT fk_PNr FOREIGN KEY (PNr) REFERENCES Person(PNr)
);

CREATE TABLE Manager(
	PNr int NOT NULL,
	Bueroadresse VARCHAR(100) NOT NULL UNIQUE,
	#managt, leitet?
	CONSTRAINT pk_PNr PRIMARY KEY (PNr),
	CONSTRAINT fk_PNr FOREIGN KEY (PNr) REFERENCES Person(PNr)
);

CREATE TABLE Album(
	Name VARCHAR(50) NOT NULL,
	Releasedatum VARCHAR(8) NOT NULL,
	Preis int NOT NULL CHECK (Preis > 5),
	Songs int NOT NULL,
	Laufzeit int NOT NULL,
	Produktion INT NOT NULL,
	CONSTRAINT pk_Name PRIMARY KEY (Name),
	CONSTRAINT fk_Produktion FOREIGN KEY (Produktion) REFERENCES Produktion(ProduktionsNr)
);

CREATE TABLE Song(
	Songwriter int NOT NULL,
	Name VARCHAR(50) NOT NULL,
	Laufzeit int NOT NULL,
	Releasedatum VARCHAR(8) NOT NULL,
	Musikrichtung VARCHAR(50) NOT NULL,
	CONSTRAINT pk_Name PRIMARY KEY (Name),
	CONSTRAINT pk_songwriter PRIMARY KEY (Songwriter),
	CONSTRAINT fk_songwriter FOREIGN KEY (Songwriter) REFERENCES Band(Name),
);

CREATE TABLE Teil_von(
	Album VARCHAR(50) NOT NULL,
	Songwriter int NOT NULL,
	Song VARCHAR(50) NOT NULL,
	CONSTRAINT pk_teil_von PRIMARY KEY (Album, Songwriter, Song),
	CONSTRAINT fk_album FOREIGN KEY (Album) REFERENCES Album(Name),
	CONSTRAINT fk_songwriter FOREIGN KEY (Songwriter) REFERENCES Song(Songwriter),
	CONSTRAINT fk_song FOREIGN KEY (Song) REFERENCES Song(Name),
);


CREATE TABLE Band(
	Name VARCHAR(50) NOT NULL,
	Gruendung DATE NOT NULL,
	Aufloesung DATE CHECK (Aufloesung = NULL OR Aufloesung > Gruendung),
	Manager INT NOT NUll,
	Gewinnbeteiligung INT NOT NULL,
	Bandleader INT NOT NULL,
	Label INT NOT NULL,
	CONSTRAINT pk_band PRIMARY KEY (Name),
	CONSTRAINT fk_manager FOREIGN KEY (Manager) REFERENCES Manager(PNr),
	CONSTRAINT fk_leader FOREIGN KEY (Bandleader) REFERENCES Musiker(PNr),
	CONSTRAINT fk_label FOREIGN KEY (Label) REFERENCES Label(Id),
);

CREATE TABLE Bandmitglied(
	Band VARCHAR(50) NOT NULL,
	Musiker int NOT NULL,
	CONSTRAINT pk_bandmitglied PRIMARY KEY (Band, Musiker),
	CONSTRAINT fk_band FOREIGN KEY (Band) REFERENCES Band(Name),
	CONSTRAINT fk_musiker FOREIGN KEY (Musiker) REFERENCES Musiker(PNr)
);

CREATE TABLE Label(
	Name VARCHAR(50) PRIMARY KEY,
	Umsatz INT,
	Ort VARCHAR(50),
	Leiter INT NOT NULL,
	CONSTRAINT fk_leiter FOREIGN KEY (Leiter) REFERENCES Manager(PNr)
); 

CREATE TABLE Produktion(
	ProduktionsNr INT PRIMARY KEY,
	Band VARCHAR(50) NOT NULL,
	Produzent INT NOT NULL,
	CONSTRAINT fk_band FOREIGN KEY (Band) REFERENCES Band(Name),
	CONSTRAINT fk_produzent FOREIGN KEY (Produzent) REFERENZES Produzent(PNr)
);
```

