# Übungsaufgabe: Änderbarkeit von Sichten

##

###

```sql
CREATE VIEW DisneysAbenteuerFilme
    AS SELECT FNr, Titel FROM Film
        WHERE Genre = 'Abenteuer'
        AND Filmstudio = 'Disney';
```

\texttt{FNr} zeigt auf einen eindeutigen Film, weshalb Änderungsoperationen in dieser Sicht erlaubt sind.

###

```sql
CREATE VIEW Genres
    AS SELECT DISTINCT Genre FROM Film
        WHERE Jahr >= 1980;
\end{verbatim}
```

Das Schlüsselwort \texttt{DISTINCT} verhindert eine eindeute Zuordnung der Tabelle; damit ist diese Sicht nicht veränderbar. 

###

```sql
CREATE VIEW SchauspielerProFilm
    AS SELECT Film AS FNr,
              COUNT(Schauspieler) AS AnzahlSchauspieler
              FROM SpieltIn;
```

Durch die genutzte Funktion \texttt{COUNT()} ist die Sicht nicht veränderbar. 

##

### AktuelleAbenteuerFilme

Die Aktualisierung verändert nur die Variable \texttt{Bewertung}; die durch \texttt{WITH CASCADED CHECK OPTION} zu beachtene Sicht \texttt{AktuelleAbenteuerFilme} spezifiziert keine Einschränkungen bezüglich dieser. Die darunterliegende Sicht \texttt{AbenteuerFilme} besitzt keine \texttt{CHECK}-Klausel und kann damit keine wirksamen Einschränkungen spezifizieren. Die Aktualisierung ist damit zulässig.

### AktuelleAbenteuerKurzFilme

Es wird versucht, die Aktualisierung \texttt{Jahr = 2017} durchzuführen; dies verstößt gegen die durch \texttt{WITH CASCADED CHECK OPTION} beachtete Bedingung \texttt{Jahr >= 2018} in \texttt{AktuelleAbenteuerKurz}. Die Aktualisierung ist damit unzulässig.

### BeliebteAktuelleAbenteuerFilme

Diese Aktualisierung ist aus dem selben Grunde wie die vorherige unzulässig; wenngleich die obere Sicht \texttt{BeliebteAktuelleAbenteuerFilme} selbst keine \texttt{CHECK}-Klausel spezifiziert, wird dennoch die der darunterliegenden Sicht \texttt{AktuelleAbenteuerFilme} beachtet.

### AbenteuerFilme

Die Sicht \texttt{AbenteuerFilme} kann mangels einer \texttt{CHECK}-Klausel keine wirksamen Einschränkungen definieren; da auch keine darunterliegende Sicht existiert, muss die Einfügung zulässig sein.